#pragma  once
#include "glwindows.h"
#include "textures.h"
#include <vector>

 
namespace glc 
{
  extern std::vector<GLuint> bound_buffers_stack;
  class DepthFBO
  {
 
    bool requires_initialization;
    bool depth_mode_shadow;
  protected:
    GLuint Buffer;
    GLsizei Height;
    GLsizei Width;
    virtual void InitBuffer();
    virtual void InitTextures();
    virtual void InitColorAttachements() {}
    virtual void ChooseBuffersToDraw();
    virtual void SetCommonTextureParam(TextureNameReference & tex);
    virtual void BoundClear();
  public:
    DepthFBO(GLsizei w, GLsizei h, bool depth_mode_shadow=true);
    TextureNameReference DepthTexture;
    void Bind();
    void Unbind();
    void Clear();
    virtual std::vector<float> ReadDepth();
    virtual std::vector<float> ReadChannel(int i);
    virtual ~DepthFBO();
  };

  class CommonFBO :public DepthFBO
  {
  protected:
    virtual void InitTextures();
    virtual void InitColorAttachements();
    virtual void ChooseBuffersToDraw();
    virtual void BoundClear();
  public:
    TextureNameReference ColorTexture;
    CommonFBO(GLsizei w, GLsizei h, bool shadowmode=true);
	std::vector<unsigned char> ReadRGB();
 

  };
  
  struct Averaging 
  {
	  static void Enable(int samples);
	  static void Disable();
  }; 

  struct MovingAveraging 
  {
    static void Enable(float lambda);
    static void Disable();
  };
  struct AlphaBlending
  {
    static void Enable();
    static void Disable();
  };

};