#pragma once
#include "glwindows.h"
#ifndef SWIG
#include <map>
#include <string>
#include <stack>
#endif

namespace glc
{
	class TextureNameReference
	{
		GLuint Name;
		static std::map<GLuint, unsigned> RefCount;
		void IncRef();
		void DecRef();
		static std::stack<GLuint> bound;
	public:

		operator GLuint () { return Name; }
		TextureNameReference();
		TextureNameReference& operator=(const TextureNameReference & src);
		TextureNameReference(const TextureNameReference& n);
		~TextureNameReference();
		void SetParameter(GLuint name, GLuint val);
	};

	class ImageTexture 
	{
		GLsizei width;
		GLsizei height;
		unsigned char* buffer;
		unsigned char* CopyRowReverseBuffer( const int color_depth, unsigned char* data );

	public:
		TextureNameReference TextureName;
		//ImageTexture(std::string file);
		ImageTexture(GLsizei w, GLsizei h);
		~ImageTexture();
		void LoadRGB(unsigned char* data);
		void LoadFloats(const float* data);

		void SetCommonTextureParam();

	};

};