#pragma  once
#include "glwindows.h"
#include "buffer_objects.h"
namespace glc{
  class CommonVertexArray
  {
    GLuint VertexArrayName;
    static std::vector<GLuint> bind_stack;
    void CheckBound();
  public:
    CommonVertexArray();
    ~CommonVertexArray();
    void Bind();
    void Unbind();
    CommonVertexAttribute BindAttribute( GLuint index );
    void SpecifyAttribute(PCommonBasicBuffer buff, CommonVertexAttribute atr, AttributeSpec spec);

    //this function should not be used to draw data specified in vertex buffers, use element buffer->draw instead
    // it is mainly intended to draw empty arrays (vertex attributes computed in the shader from vertex index)
    // NOTE: this behavior (allowing empty arrays to bind), is standard, yet might not work on the ATI cards
    void DrawInstanced(GLsizei element_count, GLsizei instance_count=1, GLenum mode = GL_TRIANGLES);
    void BindElementBuffer( CommonElementArrayBuffer & buf);
  };

  class CommonVertexAttribute
  {
  public:  
    GLuint Index;
    CommonVertexAttribute(GLuint index);  
  };
};