#pragma  once

#include <glm\core\type.hpp>
#include <string>
 

using std::string;

namespace glf
{
  struct GLInfo
  {
    int major;
    int minor;
    bool full_screen;
    //int profile;
    GLInfo(){ }
    GLInfo(int mj, int mn, bool full_screen  = true) :
      major(mj), minor(mn), full_screen(full_screen) {   }
  };

  class window
  {
    static window instance;
    static window* pinstance;    
    window() {}
    window(glm::ivec2 const & Size, string title, GLInfo v);
    void InitWindow();
    window(const window& );
    GLInfo glinfo;
    string title;
  public:
    void SwapBuffers();
    static void Open(glm::ivec2 const & size, string title, GLInfo v);
    static window* Instance();
    ~window();
   
    glm::ivec2 Size;
    glm::vec2 MouseOrigin;
    glm::vec2 MouseCurrent;
    glm::vec2 TranlationOrigin;
    glm::vec2 TranlationCurrent;
    glm::vec2 RotationOrigin;
    glm::vec2 RotationCurrent;
    int MouseButtonFlags;
    std::size_t KeyPressed[512];
    bool Closing();
    void EnableDebug();
  };
}

