#include "AcelData.h"
#include "converters.h"

AcelData::AcelData(string file)
{
  sc = sra::get_scene_representation(file);
  if (sc->GetStreamCount() >0)
	stream = sc->GetStream(0);
}

void AcelData::UpdateStream()
{
  stream->AdvanceToNextFrame();
}

shared_ptr<sra::IAcel> AcelData::PatchesAcel() 
{
  return this->sc->GetGlobals()->Property("patches");
}
 
CameraAcelAcessor AcelData::GetCamera()
{
	return CameraAcelAcessor(GetCameraAcel());
}
std::shared_ptr<sra::IAcel> AcelData::GetCameraAcel()
{
  return sc->GetGlobals()->Property("camera");
}
