#pragma once
#ifndef SWIG
#include <memory>
#endif
#include "Camera.h"
#include "converters.h"


using demo::Camera;
using glm::mat4;
using glm::vec3;

 
class CameraModule
{
  mat4 Proj;
  mat4 Model;
  vec3 position;
  vec3 direction;
  vec3 up;
  const Camera* camera;
  bool init;
public:
  CameraModule(const Camera* c);
  // execute
  glm::mat4 GetCurrentMVP( );
  // doesn't take into account possible change of camera position because of the interaction (only relevenant if camera movment is allowed
  glm::mat4 GetDoFMVP(float bokeh_x, float bokeh_y, float focal_length, float aperture);
  void AssignCameraParameters(CameraAcelAcessor cam);
};

