#pragma once
#include <memory>
#include <glm/glm.hpp> 

#include "converters.h"

#include "BasicRenderingModule.h"
#include "shader_modules/triangle.meta.h"


#ifdef SWIG
%template (BasicRenderingModule_ShaderProgramtriangle) BasicRenderingModule<ShaderProgramtriangle>;
#endif


class FixedDrawingModule : public BasicRenderingModule<ShaderProgramtriangle>
{
public:
	FixedDrawingModule() { Array = std::make_shared<ShaderProgramtriangle_VertexArray>(); }
	virtual void Draw()
	{
		WITH_BINDING(&Pipeline) {
			WITH_BINDING(Array) {
				Array->DrawInstanced(3);
			}
		}
	}
};