#pragma once
#ifndef SWIG
#include <memory>
#include <functional>
#endif
#include <scene-core/sra-api/sra_modules.h>
//#include <renderer-core/common_operations.h>
typedef std::shared_ptr<sra::IAcel> PAcel;

template<typename TArg>
class GenericConverter: public sra::IConverter
{
  typedef std::function<TArg(PAcel)> TConvert;
  typedef std::function<void( TArg)> TAssign;
  TConvert Converter;
  TAssign Assigner;
  //TMod Module;

public:
  GenericConverter(TConvert conv, TAssign asg) : Converter(conv), Assigner(asg){}
  virtual void Assign(PAcel value )
  {
    Assigner(Converter(value));
  }
};
 