#include "MeshRenderingModule.h"

#include "renderer-core/common_operations.h"
#include <scene-core/sra_implementation.h>
#include "shader_modules/basic.meta.h"

#include "MeshesConverter.h"
#include "StreamConverters.h"





void MeshRenderingModule::AssignWorldToLight( glm::mat4 m )
{
  glm::mat4 clip_to_tex(
    0.5, 0.0, 0.0, 0.0,
    0.0, 0.5, 0.0, 0.0,
    0.0, 0.0, 0.5, 0.0,
    0.5, 0.5, 0.5, 1.0
    );
  glm::vec4 pos = glm::inverse(m) * vec4(0,0,0,1);
  SetLight(glm::vec3(pos.x, pos.y, pos.z) );

  SetWorldToLightClip(clip_to_tex*m);
}
