#pragma once
#include "sra_renderer.h"
#include "Camera.h"
#ifndef SWIG
#include <memory> 
#endif
namespace glc { class DepthFBO; class CommonFBO; }

namespace demo
{
  class Renderer : public sra_render::IDemoRenderer
  {
    Camera camera; 
    int width;
    int height;
  public:
    Renderer(int width, int height);
    bool Closing();
    bool Paused();
    void BeginFrame();
    void EndFrame();
    int Width();
    int Height();
    
    void ClearBuffer();
    const Camera* GetCamera();
    std::shared_ptr<glc::CommonFBO> CreateFBO(bool shadowmode);
    std::shared_ptr<glc::DepthFBO> CreateDepthFrameBuffer(bool shadowmode);

    virtual std::shared_ptr<sra_render::ModRenderDepthMap> CreateModRenderDepthMap();
    virtual std::shared_ptr<sra_render::ModRenderMesh> CreateModRenderMesh();
    virtual std::shared_ptr<sra_render::ModViewPoint> CreateModViewPoint();
    virtual std::shared_ptr<sra_render::ModDrawSplash> CreateModDrawSplash();
    virtual std::shared_ptr<sra_render::ModComputeShadows> CreateModComputeShadows();
  };
}