#include "StreamConverters.h"

#include <string>
#include <scene-core/sra-api/sra_scene.h>

void AbstractStreamConverter::StreamTextureToGPU(std::shared_ptr<sra::IAcel> frame)
{
  if (!TexImage)
    CreateTexture(frame);
  UpdateTexture( frame);
}
void ImageStreamConverter::UpdateTexture(std::shared_ptr<sra::IAcel> frame)
{
  auto prop = frame->Property(prop_data);
  TexImage->LoadRGB((unsigned char*) prop->Value()->GetByteBuffer().Ptr());
}
void DepthStreamConverter::UpdateTexture(std::shared_ptr<sra::IAcel> frame)
{
  TexImage->LoadFloats(frame->Property(prop_data)->Value()->GetFloatBuffer().Ptr());
}


void AbstractStreamConverter::CreateTexture(std::shared_ptr<sra::IAcel> frame)
{
  TexImage = make_auto_ptr(
    new ImageTexture(
    frame->Property(prop_width)->Value()->GetInt(),
    frame->Property(prop_height)->Value()->GetInt() ));
}

glc::PImageTexture AbstractStreamConverter::LoadTexture(std::shared_ptr<sra::IAcel> frame)
{
  StreamTextureToGPU(frame);
  return TexImage;
}

