#pragma once
#include <memory>
#include <glm/glm.hpp>
#include "Renderer.h"
#include "shader_modules/depth.meta.h"
#include "shader_modules/basic.meta.h"


#include "renderer-core/common_operations.h"
#include <scene-core/sra_implementation.h>



using namespace glc;
namespace sra { class IScene; class IAcel; }


using demo::Renderer;
using demo::Camera;


using namespace glc;
using glm::mat4;
namespace sra{ class IStream; }
using std::string;

class AbstractStreamConverter
{  
protected:
  string prop_width;
  string prop_height;
  string prop_data;
  virtual void UpdateTexture(std::shared_ptr<sra::IAcel> frame) = 0;
  virtual void CreateTexture(std::shared_ptr<sra::IAcel> frame);
  PImageTexture TexImage;
  void StreamTextureToGPU(std::shared_ptr<sra::IAcel> frame);
public:
  AbstractStreamConverter(string pw, string ph, string pd): 
      prop_data(pd), prop_width(pw), prop_height(ph), TexImage(0) {}
  PImageTexture LoadTexture(std::shared_ptr<sra::IAcel> frame);
  virtual ~AbstractStreamConverter() {}
};

class ImageStreamConverter : public AbstractStreamConverter
{
protected:
  virtual void UpdateTexture(std::shared_ptr<sra::IAcel> frame) ;
public:
  ImageStreamConverter(): 
      AbstractStreamConverter(XSTREAM_INFO_VIDEO_WIDTH, XSTREAM_INFO_VIDEO_HEIGHT, XSTREAM_FRAME_VIDEO_DATA) { }
};

class DepthStreamConverter: public AbstractStreamConverter
{  
protected:
  virtual void UpdateTexture(std::shared_ptr<sra::IAcel> frame);
public:
  DepthStreamConverter(): 
      AbstractStreamConverter(XSTREAM_INFO_DEPTH_WIDTH, XSTREAM_INFO_DEPTH_HEIGHT, XSTREAM_FRAME_DEPTH_DATA) { }
};

