#include "scene_demo.h"
//#include <functional>
//#include "GenericConverter.h"
//#include "DummyAcel.h"
//#include "CameraModule.h"

#include <string>

#include "SplashDrawModule.h"
#include "StreamConverters.h"
#define TEST_MESH
#define TEST_SHADOW
//#define TEST_SPLASH



#ifdef TEST_MESH
const bool FROM_DEPTH = false;
const std::string SCENE_FILE = "../../sample_data/monkey.scene";
#else
#ifdef TEST_SPLASH

const bool FROM_DEPTH = false;
const std::string SCENE_FILE = "../../sample_data/monkey.scene";

#else
const bool FROM_DEPTH = true;
//const std::string SCENE_FILE = "../sample_data/cube_anim.scene";
//const std::string SCENE_FILE = "../sample_data/buck/collada.scene";
const std::string SCENE_FILE = "../../sample_data/collada.scene";
#endif
#endif

 

void SceneApp::Render()
{
  if (FROM_DEPTH)
    RenderDepthData();
  else
#ifdef TEST_SHADOW 
   RenderShadowMesh();
#else
    RenderMeshes();

#endif
}

//template <typename T>
//std::shared_ptr<T> make_auto_ptr(T* o) {return std::shared_ptr<T>(o); }

ImageStreamConverter* images;
void SceneApp::Run()
{
  data = make_auto_ptr( new AcelData(SCENE_FILE));
  renderer = sra_render::get_proto_renderer(0, "");
  mod_render_mesh = renderer->CreateModRenderMesh();
  mod_render_depth = renderer->CreateModRenderDepthMap();
  mod_camera = renderer->CreateModViewPoint();
  mod_draw_splash = renderer->CreateModDrawSplash();
  mod_compute_shadows = renderer->CreateModComputeShadows();

  images = new ImageStreamConverter();

  if (FROM_DEPTH)
    mod_render_depth->CameraSettings->Assign(data->GetCameraAcel());

  mod_camera->CameraSettings->Assign(data->GetCameraAcel());
  first_camera = mod_camera->Execute();
  while(!renderer->Closing())
  {
    renderer->BeginFrame();
    Render();
    renderer->EndFrame();
  }
}

void SceneApp::RenderDepthData()
{
  if (!this->renderer->Paused())
    data->UpdateStream();
  mod_render_depth->Transform->Assign(mod_camera->Execute());
  auto stream_frame = data->stream->GetCurrentFrame();
  mod_render_depth->DepthMap->Assign(stream_frame);
  mod_render_depth->Texture->Assign(stream_frame);
  mod_render_depth->Execute();
}

void SceneApp::RenderMeshPart()
{
  auto stream_frame  = data->stream->GetCurrentFrame();
  mod_render_mesh->Texture->Assign(stream_frame);
  auto patches = data->PatchesAcel();
  auto patches_list = patches->List();
  for (int i=0; i< patches_list->Count(); i++)
  {
    mod_render_mesh->Mesh->Assign(patches_list->Get(i));
    mod_render_mesh->Execute();
  }
}
void SceneApp::RenderShadowMesh()
{
  if (!this->renderer->Paused())
    data->UpdateStream();
  mod_render_mesh->Transform->Assign(first_camera);

  mod_compute_shadows->Begin();
  RenderMeshPart();
  mod_compute_shadows->End();

  mod_render_mesh->ShadowTransform->Assign(first_camera);
  mod_render_mesh->ShadowMap->Assign(mod_compute_shadows->Execute());
  mod_render_mesh->Transform->Assign(mod_camera->Execute());
  RenderMeshPart();

}


void SceneApp::RenderMeshes()
{
  if (!this->renderer->Paused())
    data->UpdateStream();
#ifdef TEST_MESH 
  mod_render_mesh->Transform->Assign(mod_camera->Execute());
  RenderMeshPart();
#else
  mod_draw_splash->Texture->Assign(stream_frame);
  mod_draw_splash->Execute();
#endif 

}
 