#pragma once 
#include "sra_renderer.h"
#include "AcelData.h"
 
class SceneApp
{
  std::shared_ptr<sra_render::IDemoRenderer> renderer;
  std::shared_ptr<sra_render::ModViewPoint> mod_camera;
  std::shared_ptr<sra_render::ModRenderMesh> mod_render_mesh;
  std::shared_ptr<sra_render::ModRenderDepthMap> mod_render_depth;
  std::shared_ptr<sra_render::ModDrawSplash> mod_draw_splash;
  std::shared_ptr<sra_render::ModComputeShadows> mod_compute_shadows;
private:
  std::shared_ptr<AcelData> data;
  std::shared_ptr<sra::IAcel> first_camera;
  virtual void Render();
  void RenderMeshes();
  void RenderDepthData();
  void RenderShadowMesh();
  void RenderMeshPart();

public:
  void Run();
};


