#version 330 core

#define VERTEX_SHADER
#include "fbo-splash.glsl"
#include "texturing.h"
#include "lighting.h"
#include "shadows.h"

#include "util.h"

 
layout(location = 1) in vec3 Position;
layout(location = 2) in vec3 Normal;
layout(location = 3) in vec2 TexCoord;



uniform mat4 MVP;


out gl_PerVertex
{
  vec4 gl_Position;
};


void main()
{
    Texcoord = TexCoord;
    NormalWorld = Normal;
    PositionWorld = Position;
    vec4 pos_world = vec4(Position, 1.0);
    output_shadow(pos_world);
    gl_Position = MVP * pos_world;
}

