
#ifdef VERTEX_SHADER
#define PARAM out
#endif

#ifdef FRAGMENT_SHADER
#define PARAM in
#endif


PARAM vec3 NormalWorld;
PARAM vec3 PositionWorld;



 
#ifdef FRAGMENT_SHADER
uniform vec3 Light;
float gouraud(vec3 light, vec3 normal, vec3 v)
{
  float diffuse = 1.0;
  vec3 L = normalize(light - v);
  float Idiff = diffuse * max(dot(normal, L), 0.0);
  Idiff = clamp(Idiff, 0.0, 1.0);
  return Idiff;
}

vec4 color_light()
{
  float I  = gouraud(Light, NormalWorld, PositionWorld);
  return vec4(0.1, 0.8, 0.3, 1.0) * (0.5 + 0.5*I);
  //return vec4(1.0, 0.5, 1.0, 1.0) * (0.95 +0.0005*I);
}
#endif
