//#ifndef SCREEN_GRID_H
//#define SCREEN_GRID_H

uniform ivec2 WinSize;


vec2 screen_to_ndc(vec2 pixel)
{
	return 2* pixel / WinSize - vec2(1.0, 1.0);
}

// return screen coordinates of a pixel
in int gl_InstanceID; 

vec2 screen_grid_current_pixel()
{
    int id = gl_InstanceID ;
    return vec2(
        float(id % WinSize.x),
        float(id / WinSize.x)
        ) ;
}

//-------------------------quad
const vec2 quad[] = 
vec2[](
  vec2(0.0f, 0.0),
  vec2(1.0f,0.0),
  vec2(0.0f, 1.0),
    
   
  vec2(1.0f,0.0),
  vec2(1.0f, 1.f),
  vec2(0.0f, 1.0)
  );

 
 
 

in int gl_VertexID;
vec2 screen_grid_current_quad_vertex(int off)
{
  return quad[(gl_VertexID +off)% 6];
}
//end -------------------------qiad


struct triangle_ndc
{
  vec2 a, b, c;
};
 

triangle_ndc get_current_triangle(vec2 pixel)
{
  triangle_ndc res;
  res.a = screen_to_ndc(pixel + screen_grid_current_quad_vertex(0));
  res.b = screen_to_ndc(pixel + screen_grid_current_quad_vertex(-1 ));
  res.c = screen_to_ndc(pixel + screen_grid_current_quad_vertex(1));
  return res;
};

