#version 330 core

#include "fbo-splash.glsl"

layout(binding = BIND_DIFFUSE) uniform sampler2D Diffuse;
layout(binding = BIND_DEPTH) uniform sampler2D Depth;
layout(binding = BIND_DOF) uniform sampler2D DepthOfField;


in vec4 gl_FragCoord;
layout(location = FRAG_COLOR, index = 0) out vec4 Color;
 
uniform vec2 screen_size;
//#define SHOW_DEPTH
uniform float Aperture ;
uniform float FocalLength ;
const float ScreenDistance = 0.01; 
const float K= screen_size.x*1000.0;
   


void main()
{   
    float depth = texture(Depth,  gl_FragCoord.xy/screen_size).r;
    float focal_length = 0.0;
    
    focal_length = texture(DepthOfField, gl_FragCoord.xy/screen_size).r ;    
    if (focal_length == 0.0)    
        focal_length = FocalLength;


    int cocd =  int(round(abs(  Aperture * ( K*ScreenDistance*(1.0/focal_length- 1.0/depth) - 1.0 ) )));
    //cocd = int(cocd * 0.0001)  + 10;
    vec4 cc = vec4(0.0, 0.0, 0.0, 0.0);
    float w = 0.0;

    for (int i=-cocd; i<=cocd; i++)
        for (int j=-cocd; j<=cocd; j++)
            if (i*i + j*j <= cocd*cocd)
            {
                cc += texture(Diffuse, (gl_FragCoord.xy +vec2(float(i), float(j))) / screen_size);
                w += 1.0;
            }
  
    cc.xyz /= w;

    cc.w = 1.0;
    // cc.x = (cc.x + cc.y + cc.z )/ 3.0 ;     
    // cc.y = cocd;
    // cc.z = depth;     
    Color = cc;
}



