layout(binding = BIND_DEPTH) uniform sampler2D Depth;

float get_z_eye(vec2 pos_ndc)
{
  return -texture(Depth, ndc_to_tex(pos_ndc)).x;
}


uniform vec2 TgFov;
vec4 get_pos_eye(vec2 pos_ndc, float z_eye)
{
  vec2 pos_eye = -pos_ndc * z_eye * TgFov;
  return vec4(pos_eye.x, pos_eye.y, z_eye, 1.0);
}


vec4 ndc_to_eye(vec2 pos_ndc)
{
  return get_pos_eye(pos_ndc, get_z_eye(pos_ndc));
}

// move it to geometry.h
struct triangle
{
  vec4 a, b, c;
};

triangle triangle_ndc_to_eye(triangle_ndc t)
{
  triangle res;
  res.a = ndc_to_eye(t.a);
  res.b = ndc_to_eye(t.b);
  res.c = ndc_to_eye(t.c);
  return res;
}
bool triangle_cutoff_z(triangle t_eye, float thresh)
{
  return 
    abs(t_eye.b.z - t_eye.a.z) >  thresh ||
    abs(t_eye.c.z - t_eye.a.z) >  thresh;
}


