#include "splash.h"
#include <renderer-core/tricks.h>

SplashPipeline::SplashPipeline()
{
  Pipeline = make_auto_ptr(new CommonPipeline());
  Program =  make_auto_ptr(new ShaderProgramsplash());
  Pipeline->InstallProgram(*Program);
  Array = make_auto_ptr(new CommonVertexArray());
}

void SplashPipeline::Draw(PImageTexture& txt)
{
  WITH_BINDING(Pipeline) 
  {
    WITH_BINDING(Array)
    { 
      Program->AssignTextureDiffuse(txt);
      Array->DrawInstanced(3);
    } 
  }
}
