#include "sra_renderer.h"
#include "Renderer.h"
#include <renderer-core\tricks.h>

#include "DepthRenderingModule.h"
#include "CameraModule.h"
#include "MeshRenderingModule.h"
#include "SplashDrawModule.h"
#include "ShadowComputationModule.h"

using namespace sra_render;
using namespace glc;
using namespace demo;
using std::shared_ptr;


std::string REN_SHADERS_PATH = ".";
bool REN_USE_OPENGL_42 = false;
bool REN_FULL_SCREEN = false;
bool ORANGE_BACKGROUND = true;


extern int REN_VIEWPORT_WIDTH = 1280;
extern int REN_VIEWPORT_HEIGHT = 720;
extern float REN_DEPTH_TRESHOLD = 0.07;


std::shared_ptr<IDemoRenderer> sra_render::get_proto_renderer(shared_ptr<sra::IScene> scene, string config )
{
  return make_auto_ptr(new Renderer(REN_VIEWPORT_WIDTH, REN_VIEWPORT_HEIGHT) ) ;
}

shared_ptr<ModRenderDepthMap> Renderer::CreateModRenderDepthMap()
{
  return make_auto_ptr(new sra_render::ModRenderDepthMap(
    make_auto_ptr( 
    new DepthMapRenderingModule(this->Width(), this->Height()))));
}

shared_ptr<ModRenderMesh> Renderer::CreateModRenderMesh()
{
  return make_auto_ptr(new sra_render::ModRenderMesh(make_auto_ptr(new MeshRenderingModule())));
}

shared_ptr<ModViewPoint> Renderer::CreateModViewPoint()
{
  return make_auto_ptr(
    new sra_render::ModViewPoint(
    make_auto_ptr(new CameraModule(GetCamera()))));
}
std::shared_ptr<ModDrawSplash> Renderer::CreateModDrawSplash()
{
  return make_auto_ptr(new sra_render::ModDrawSplash( make_auto_ptr(new SplashDrawModule(REN_VIEWPORT_WIDTH, REN_VIEWPORT_HEIGHT))));
}

std::shared_ptr<ModComputeShadows> demo::Renderer::CreateModComputeShadows()
{
  return make_auto_ptr(new sra_render::ModComputeShadows(
    make_auto_ptr(new ShadowComputationModule(this->CreateDepthFrameBuffer(true)))));
}

