#pragma once
#include "renderer-core/common_operations.h"
#include "renderer-core/vertex_arrays.h"

#ifndef SWIG
#include <vector>
#include <string>
#include <memory>
#endif

extern std::string REN_SHADERS_PATH;

using glm::mat4;
using glm::vec2;
using glm::vec3;
using glm::vec4;
using glm::ivec2;

using glc::VertexFragmentProgram;
using glc::PImageTexture;
using glc::TextureNameReference;
using glc::CommonVertexArray;
using glc::CommonBasicBuffer;
using glc::CommonElementArrayBuffer;


<%include file="array.mako"/>

class ${prog.class_name} : public VertexFragmentProgram
{ 
public:
  std::shared_ptr<${prog.class_name}_VertexArray> Array;
  void SetArray(std::shared_ptr<${prog.class_name}_VertexArray> a)  { Array = a; }
  virtual void DrawArray() 
  { 
     Array->Bind();
     Array->DrawTrianglesInstanced(); 
     Array->Unbind();
  }
##
  % for field in prog.simple_uniforms:
  void Set${field.cname}(${field.type} ${field.cname}) { ${field.gen_uniform_set()}; }
  % endfor
##
  
  % for f in prog.samplers:
  void AssignTexture${f.name}(PImageTexture txt ) { BindTexture(${f.binding}, txt->TextureName); } 
  void BindTexture${f.name}(TextureNameReference txt ) { BindTexture(${f.binding}, txt); } 
  % endfor

  ${prog.class_name}() :
    VertexFragmentProgram(
      REN_SHADERS_PATH + "/${prog.fragment_shader_file}",
      REN_SHADERS_PATH + "/${prog.vertex_shader_file}")
  {
  }
};


