from util_scene import DemoScene
from util_rendering import DemoRenderer, new_demo_camera,  in_frame, frame_alpha_blending, RenderMask, RenderSplash
from util_framebuffer import color_frame_buffer
from util_testing import image_save
 
from scene import cvar
from util_drawing import *

EnableLighting = True
cvar.REN_DEPTH_TRESHOLD =  1121

sample_dir = "../../sample_data/"
demo_buck = sample_dir + "buck/buck.scene"
demo_hhi = sample_dir + "small_hhi/small_hhi.scene"
demo_girl = sample_dir +"man/girl.scene"
demo_dto = sample_dir + "data4/sample_data/dto.scene"
demo_surrey = sample_dir + "sample_data_surrey/surrey2.scene"
demo_man = demo_girl

#demo_man = "../sample_data/man/mannequin_ui16.scene"
 

# overlay = RenderMask(screen_size)
# with no_background():
#   fbo = color_frame_buffer(ren)   
#   with in_frame(ren):         
#     while not ren.Closing() :
#       s.next_frame()    
#       image_frame = s.get_image_frame()

#       with fbo:   
#         with in_frame(ren):                 
#           splash.draw(image_frame)

#       splash.draw(fbo.ColorTexture)
#       with frame_alpha_blending():
#         overlay.draw(image_frame)   
 
save_frames = False

def run_demo_superpixels(data):
  ren = DemoRenderer()    
  screen_size = (ren.w, ren.h)
  cam = new_demo_camera(ren, data)
  s = data.streams[0]   
  mask_stream = data.streams[1]

  sdepth  = DepthFrameStreamDrawing(cam, ren, s)
  smesh  = MeshFrameDrawing(cam, ren, data)

  if EnableLighting:
    sh = ShadowMapper(data, ren)

  overlay = RenderMask(screen_size)
  fbo = color_frame_buffer(ren)   
  splash = RenderSplash(screen_size)
  mask = None
  i = 0

  while not ren.Closing() :
    with fbo:
      with in_frame(ren) :
        #fetch data for current frame
        if not ren.Paused():
          s.next_frame()
          mask_stream.next_frame()
          mask = mask_stream.get_image_frame()

        if EnableLighting:
          sh.compute(smesh, sdepth)
          #render from camera point of view
          #sh.compute(smesh)
          #set shadow texture
          sh.apply(smesh, sdepth)

        sdepth.draw()
        smesh.draw()    

    def draw():    
      splash.draw(fbo.ColorTexture)    
      with frame_alpha_blending():
        overlay.draw(mask) 

    if save_frames:

      res_fbo = color_frame_buffer(ren)
      i += 1
      with image_save("man_overlay%03d"%i, res_fbo):        
        draw()
    else:
      draw()



def run_demo(data):
  ren = DemoRenderer()    
  screen_size = (ren.w, ren.h)
  cam = new_demo_camera(ren, data)
  s = data.streams[1]   

  sdepth  = DepthFrameStreamDrawing(cam, ren, s)
  smesh  = MeshFrameDrawing(cam, ren, data)

  mask = None

  while not ren.Closing() :
      with in_frame(ren) :
        #fetch data for current frame
        if not ren.Paused():
          s.next_frame()
        sdepth.draw()
        smesh.draw()    

#run_demo_superpixels(DemoScene(demo_man))
run_demo(DemoScene(demo_surrey))
 