from util_scene import DemoScene
from util_rendering import DemoRenderer, new_demo_camera,  in_frame

import scene
from util_drawing import *
from util_testing import image_check, image_save  
from util_framebuffer import color_frame_buffer


demo_girl = "../../sample_data/man/girl.scene"

scene.cvar.REN_DEPTH_TRESHOLD =  1121

class TestFixture:
  def  test_girl_shadows(data):
    data = DemoScene(demo_girl)
    ren =  DemoRenderer(512, 288)
    cam = new_demo_camera(ren, data)
    s = data.streams[0]   
    s.next_frame()
    sdepth  = DepthFrameStreamDrawing(cam, ren, s)
    smesh  = MeshFrameDrawing(cam, ren, data)
    shadows = ShadowMapper(data, ren)
    with image_check("girl_shadows", color_frame_buffer(ren)):
      with in_frame(ren) :
          #render from camera point of view
          shadows.compute(sdepth, smesh)
            #set shadow texture
          shadows.apply(sdepth, smesh)
          sdepth.draw()
          smesh.draw()      
     
   