import numpy as np

def tfile_name(name):
  return "testing/%s.png" % name

def tsave_numpy(name, obj):
   
  with open(tfile_name(name), "wb") as f:
    np.save(f, obj)

def tload_numpy(name):  
  with open(tfile_name(name), "rb") as f:
    return np.load(f)

def float_array_equal(a, b):  
  return np.max(np.abs(a  - b)) < 1e-6

def float_equal(a, b):
  res = abs(a  - b) < 1e-4
  if not res:
    print(a, b)
  return res


def check_image(a, b):
  import util
  read = util.util_image.read_rgb_image_as_str
  assert read(a) == read(b)

def check_mat(name, mat):
  old = tload_numpy(name)
  assert(float_array_equal(mat, old))
 

 
from contextlib import contextmanager
import os.path
   


def stored_image_check(name, read_image):  
  if os.path.exists(tfile_name(name)):
    read_image().save("tmp.png")
    check_image(tfile_name(name), "tmp.png") 
  else:
    import sys
    sys.stderr.write("Warning: no test file to check against. Generating one.")  
    read_image().save(tfile_name(name))


def fbo_check(name, fbo):  
  stored_image_check(name, fbo.read_image)
  

@contextmanager
def image_check(name, fbo):  
  from util_rendering import in_frame
   
  with fbo :
    with in_frame(fbo.renderer):
      yield  
      
  fbo_check(name, fbo)     
     
@contextmanager
def image_save(name, fbo):  
  from util_rendering import in_frame
  with fbo :
    with in_frame(fbo.renderer):
      yield    
    fbo.read_image().save(name + ".png")
  

 